         PRINT NOGEN
         BEGIN NAME=QFN1,IBM=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*        URFER     TD00702 09/26/96    CREATE DRIVER                  *
*        URFER     TD00712 12/02/96    ADD VERIFY OPTION TO DRIVER    *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
***********************************************************************
*
*   MODULE NAME..... QFN1 START/STOP PROCESSING
*   RELATED MODULE.. QFN3 TO PERFORM COMMITS/ROLLBACKS
*   DESCRIPTION..... CONTROL STARTING AND STOPPING OF CORO DRIVER
*   LEVEL........... VERSION 1  MODIFICATION 0
*
*   FUNCTION... QFN1 IS DIVIDED INTO  FUNCTIONS -
*                     STARTING THE DRIVER
*                     STOPPING THE DRIVER
*                     DISPLAY THE STATUS
*                     MAINTAIN THE ACTIVITY LEVELS
***********************************************************************
         EJECT
***********************************************************************
*   JUMP AROUND TIMESTAMP
***********************************************************************
         B     QXRMJUMP
         DC    CL8'&SYSDATE',CL1' ',CL8'&SYSTIME'
***********************************************************************
*   BRANCH TABLE
***********************************************************************
QXRMJUMP DS    0H
         SD0RV REG=R6                  I-S SHARED DRIVER GLOB REC
         GLOBZ REGR=R14
***********************************************************************
* PROCESS COMMAND
***********************************************************************
         L     R6,@ISSDRV              GET ADDRS TO I-S SHARED GLOBAL
* NON LOCKED COMMANDS
         CLC   EBW000(4),=C'STAT'      STATUS REQUEST
         BE    QFN10300
         CLC   EBW000(4),=C'RESE'      RESET REQUEST
         BE    QFN10700
* LOCKED COMMANDS
         BAS   R4,LOCK                 LOCK THE GLOBAL RECORD
         CLC   EBW000(4),=C'STAR'      START REQUEST
         BE    QFN10000
         CLC   EBW000(4),=C'CRET'      RUNNING MODE
         BE    QFN10100
         CLC   EBW000(4),=C'STOP'      STOP REQUEST
         BE    QFN10200
         CLC   EBW000(4),=C'DONE'      LOOK TO SEE IF WE ARE DONE
         BE    QFN10400
         CLC   EBW000(4),=C'ONCE'      ONCE CMD
         BE    QFN10500
         CLC   EBW000(4),=C'ALTE'      ALTER REQUEST
         BE    QFN10600
         CLC   EBW000(4),=C'VERI'      VERIFY REQUEST
         BE    QFN10800
         B     UNLOCK
         EJECT
***********************************************************************
*
*                     START COMMAND
*
***********************************************************************
*
QFN10000 DS    0H
         TM    SD0FLG1,X'FF'           IS IT RUNNING
         BZ    QFN10001
         WTOPC TEXT='CORO DRIVER IS ALREADY ACTIVE, START REJECTED',   X
               NUM=1,LET=E,ROUT=(PRC,RO,RDBS)
         B     UNLOCK
***********************************************************************
*  LOAD THE ECBS NUMBER TO THE GLOBAL RECORD
***********************************************************************
QFN10001 DS    0H
         NI    SD0FLG3,255-SD03PRT     turn off prt flag
         L     R1,CE1CR0
         L     R14,12(R1)              LOAD POINTER TO ECBS
         LTR   R14,R14
         BNZ   QFN10005
         LA    R14,1                   default ECB= to 1
         B     QFN10010
         SPACE 1
QFN10005 DS    0H
         L     R14,0(,R14)
QFN10010 DS    0H
         STH   R14,SD0MECB
***********************************************************************
*  LOAD THE NEST NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         L     R14,16(R1)              LOAD POINTER TO NEST
         LTR   R14,R14
         BNZ   QFN10015
         LA    R14,3                   default nesting= to 3
         B     QFN10020
         SPACE 1
QFN10015 DS    0H
         L     R14,0(,R14)             nesting level default is 3
QFN10020 DS    0H
         STH   R14,SD0NEST
***********************************************************************
*  LOAD THE RIAT NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         L     R14,20(R1)              LOAD POINTER TO RIAT
         LTR   R14,R14
         BNZ   QFN10030
         MVC   SD0RIAT,=C'LL'
         B     QFN10040
QFN10030 DS    0H
         CLC   1(3,R14),=C'SDP'  byte 0 is length,
         BNE   QFN10031
         MVC   SD0RIAT,=C'SL'
         B     QFN10040
*
QFN10031 DS    0H
         CLC   1(3,R14),=C'LDP'  byte 0 is length,
         BNE   QFN10032
         MVC   SD0RIAT,=C'LL'
         B     QFN10040
*
QFN10032 DS    0H
         CLC   1(3,R14),=C'4DP'  byte 0 is length,
         BNE   QFN10033
         MVC   SD0RIAT,=X'00E8'
         B     QFN10040
*
QFN10033 DS    0H
         CLC   1(3,R14),=C'SST'  byte 0 is length,
         BNE   QFN10034
         MVC   SD0RIAT,=C'SS'
         B     QFN10040
*
QFN10034 DS    0H
         CLC   1(3,R14),=C'LST'  byte 0 is length,
         BNE   QFN10035
         MVC   SD0RIAT,=C'LS'
         B     QFN10040
*
QFN10035 DS    0H
         MVC   SD0RIAT,=X'00F3'
***********************************************************************
*  LOAD THE FA NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
QFN10040 DS    0H
         L     R14,24(R1)              LOAD POINTER TO FA
         LTR   R14,R14
         BNZ   QFN10050
         LA    R14,1                   default FA to 1
         B     QFN10051
         SPACE 1
QFN10050 DS    0H
         L     R14,0(,R14)
QFN10051 DS    0H
         STH   R14,SD0FCNT
***********************************************************************
*  LOAD THE CRETC INTERVAL ->GLOBAL RECORD
***********************************************************************
*
QFN10060 DS    0H
         L     R14,28(R1)              LOAD POINTER TO FA
         LTR   R14,R14
         BNZ   QFN10061
         LA    R14,1                  DEFAULT = 1
         B     QFN10062
         SPACE 1
QFN10061 DS    0H
         L     R14,0(,R14)
QFN10062 DS    0H
         STC   R14,SD0FLG4
***********************************************************************
* MARK CORO AS BEING ACTIVE AND EXIT IF STARTING THE DRIVER ELSE EXIT
***********************************************************************
*
         MVC   SD0FLG1,CE1ISN+1        Copy active IS number            D10939
         LA    R14,1                   CRET BACK TO SELF IN 1  SECONDS
         L     R15,=C'CRET'            MARK ECB AS A CRET ECB
         CRETC S,QFN1,STATE=1052
QFN10070 DS 0H
         B     UNLOCK
         EJECT
***********************************************************************
*
*                     CRET COMMAND
*
***********************************************************************
*
*  IF CORO IS NOT ACTIVE, EXIT
*
QFN10100 DS    0H
         NI    SD0FLG3,255-SD03PRT     turn off prt flag
         TM    SD0FLG1,X'FF'            LOAD CORO STATUS BYTE           D10939
         BZ    UNLOCK                  CORO IS NOT ACTIVE, QUIT         D10939
***********************************************************************
*  CREATE SOME ECBS
***********************************************************************
QFN10110 DS    0H
         SR    R2,R2                  CLEAR R2
         SR    R1,R1                  CLEAR R1
         LH    R2,SD0MECB             GET COUNT OF MAX ECBS
         LH    R1,SD0AECB             GET COUNT OF ECBS RUNNING
         SR    R2,R1                  NUMBER TO CREATE
         BNH   QFN10191               IF = 0 THEN SKIP
*
QFN10120 DS    0H                     CREATE A CORO ECB
         LR    R15,R2                 PASS ORDINAL NUMBER
*        ST    R15,EBW000             IN EBW000
*        LA    R15,EBW000
*        BAS   R4,GETISN              GET A RAND IS NUMBER
*        LA    R14,4                  PASS 4 BYTES
*        SWISC QFN3,TYPE=CREATE,IS=R5,LIST=#CLHRDY,LEV=NONE
         LA    R14,1
         CRETC S,QFN3,STATE=1052
         LH    R1,SD0AECB             GET COUNT OF ECBS RUNNING
         LA    R1,1(R1)               ADD ONE TO IT
         STH   R1,SD0AECB             STORE IT
         BCT   R2,QFN10120
***********************************************************************
* CRET BACK TO SELF LATER
***********************************************************************
QFN10191 DS    0H
         SR    R14,R14
         IC    R14,SD0FLG4         GET TIME FROM GLOBAL FIELD
         L     R15,=C'CRET'
         CRETC S,QFN1,STATE=1052
         B     UNLOCK
         EJECT
*******************************************************************
*
*                     STOP COMMAND
*
*******************************************************************
QFN10200 DS    0H
         TM    SD0FLG1,X'FF'      LOAD CORO STATUS BYTE                 D10939
         BNZ   QFN10210                                                 D10939
         WTOPC TEXT='CORO DRIVER IS NOT ACTIVE, STOP REJECTED',        X
               NUM=2,LET=E,ROUT=(PRC,RO,RDBS)
         B     UNLOCK
***********************************************************************
*
* MARK STOP IN PROGRESS FIELD
*
***********************************************************************
QFN10210 DS    0H
         MVI   SD0FLG1,X'FF'        STOP CREATING ECBS                  D10939
         SR    R0,R0
         STH   R0,SD0MECB            CLEAR COUNTS OF MAX    ECBS
         WTOPC TEXT='CORO DRIVER IS NOW STOPPING..',                   X
               NUM=3,ROUT=(PRC,RO,RDBS)
         LA    R14,1
         L     R15,=C'DONE'                         GO INTO WATCH MODE
         CRETC S,QFN1,STATE=1052
         B     UNLOCK
         EJECT 1
*******************************************************************
*
*                     STAT COMMAND
*
*******************************************************************
QFN10300 DS    0H
         MVI   SD0FLG2,X'00'           JUST LOOKING THANK YOU
         CLC   SD0FLG1,CE1ISN+1        Check IS number                  D10939
         BE    QFN10320                Driver is active                 D10939
***********************************************************************
* DRIVER IS NOT ACTIVE
***********************************************************************
         WTOPC TEXT='CORO DRIVER IS NOT ACTIVE',                       X
               NUM=4,ROUT=(PRC,RO,RDBS)
         B     EXIT
***********************************************************************
* DRIVER IS ACTIVE
***********************************************************************
QFN10320 DS    0H
         SR    R2,R2
         LH    R2,SD0AECB
         SR    R3,R3
         LH    R3,SD0MECB
         SR    R4,R4
         LH    R4,SD0NEST
         SR    R5,R5
         LH    R5,SD0FCNT
         SR    R7,R7
         IC    R7,SD0FLG4              GET THE CRETC TIME IN R7
         WTOPC TEXTA=DISP1,NUM=6,ROUT=(PRC,RO,RDBS),                   X
               SUB=(DEC,(R3),DEC,(R4),HEX4A,SD0RIAT,DEC,(R5),          X
               DEC,(R7),DEC,(R2),DECA,SD0CMT,DECA,SD0RLB)
         B     EXIT
         EJECT 1
***********************************************************************
*
*                     DONE COMMAND
*
***********************************************************************
QFN10400 DS    0H
***********************************************************************
*  CHECK ADD ECBS
***********************************************************************
QFN10410 DS    0H
         LH    R1,SD0AECB             GET COUNT OF ECBS RUNNING
         LTR   R1,R1
         BNZ   QFN10490               STILL RUNNING
***********************************************************************
* DRIVER IS DEAD TELL OPERATOR
***********************************************************************
         WTOPC TEXT='CORO DRIVER IS NOW STOPPED',                      X
               NUM=7,ROUT=(PRC,RO,RDBS)
         MVI   SD0FLG1,X'00'        MARK STOPPED
         MVI   SD0FLG2,X'00'        MARK STOPPED
         MVI   SD0FLG3,X'00'        MARK STOPPED
         MVI   SD0FLG4,X'00'        MARK STOPPED
         SR    R0,R0
         STH   R0,SD0MECB            CLEAR COUNTS OF MAX    ECBS
         STH   R0,SD0NEST
         STH   R0,SD0RIAT
         ST    R0,SD0CMT
         ST    R0,SD0RLB
         STH   R0,SD0FCNT
         B     EXIT
***********************************************************************
* DRIVER IS STILL RUNNING, KEEP CHECKING
***********************************************************************
QFN10490 DS    0H
         LA    R14,3                       LOOK EVERY THREE SECONDS
         L     R15,=C'DONE'
         CRETC S,QFN1,STATE=1052
         B     UNLOCK
         EJECT
***********************************************************************
*
*                     ONCE  COMMAND
*
***********************************************************************
*
         SPACE 1
QFN10500 DS    0H
         MVI   SD0FLG2,X'00'        UNLOCK DRIVER
         L     R1,CE1CR0
***********************************************************************
*  LOAD THE NEST NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         L     R14,16(R1)              LOAD POINTER TO NEST
         LTR   R14,R14
         BNZ   QFN10515
         LA    R14,3                   default nesting= to 3
         B     QFN10520
         SPACE 1
QFN10515 DS    0H
         L     R14,0(,R14)             nesting level default is 3
QFN10520 DS    0H
         STH   R14,SD0NEST
***********************************************************************
*  LOAD THE RIAT NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         L     R14,20(R1)              LOAD POINTER TO RIAT
         LTR   R14,R14
         BNZ   QFN10530
         MVC   SD0RIAT,=C'LL'
         B     QFN10540
QFN10530 DS    0H
         CLC   1(3,R14),=C'SDP'  byte 0 is length,
         BNE   QFN10531
         MVC   SD0RIAT,=C'SL'
         B     QFN10540
*
QFN10531 DS    0H
         CLC   1(3,R14),=C'LDP'  byte 0 is length,
         BNE   QFN10532
         MVC   SD0RIAT,=C'LL'
         B     QFN10540
*
QFN10532 DS    0H
         CLC   1(3,R14),=C'4DP'  byte 0 is length,
         BNE   QFN10533
         MVC   SD0RIAT,=X'00E8'
         B     QFN10540
*
QFN10533 DS    0H
         CLC   1(3,R14),=C'SST'  byte 0 is length,
         BNE   QFN10534
         MVC   SD0RIAT,=C'SS'
         B     QFN10540
*
QFN10534 DS    0H
         CLC   1(3,R14),=C'LST'  byte 0 is length,
         BNE   QFN10535
         MVC   SD0RIAT,=C'LS'
         B     QFN10540
*
QFN10535 DS    0H
         MVC   SD0RIAT,=X'00F3'
*
***********************************************************************
*  LOAD THE PRT FLAG TO THE GLOBAL RECORD
***********************************************************************
*
QFN10540 DS    0H
         NI    SD0FLG3,255-SD03PRT     turn off prt flag
         L     R14,24(R1)              LOAD POINTER TO PRT
         LTR   R14,R14
         BZ    QFN10550
         CLI   1(R14),C'Y'             prt=Y ?
         BNE   QFN10550
QFN10545 DS    0H
         OI    SD0FLG3,SD03PRT         turn on prt flag
***********************************************************************
*  LOAD THE FA NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
QFN10550 DS    0H
         L     R14,28(R1)              LOAD POINTER TO FA
         LTR   R14,R14
         BNZ   QFN10560
         LA    R14,1                   default FA to 1
         B     QFN10561
         SPACE 1
QFN10560 DS    0H
         L     R14,0(,R14)
QFN10561 DS    0H
         STH   R14,SD0FCNT
***********************************************************************
* RUN CORO JUST ONCE WITH NEST AND POOLID SUPPLIED
***********************************************************************
*
         LH    R1,SD0AECB             GET COUNT OF ECBS RUNNING
         LA    R1,1(R1)               ADD ONE TO IT
         STH   R1,SD0AECB             STORE IT
         LA    R15,1                  SET  ORDINAL NUMBER = 1
*        ST    R15,EBW000             IN EBW000
*        LA    R15,EBW000
*        BAS   R4,GETISN              GET A RAND IS NUMBER
*        LA    R14,4                  PASS 4 BYTES
*        SWISC QFN3,TYPE=CREATE,IS=R5,LIST=#CLHRDY,LEV=NONE
         LA    R14,1
         CRETC S,QFN3,STATE=1052
         B     UNLOCK
         SPACE 1
***********************************************************************
*
*                     ALTER COMMAND
*
***********************************************************************
*
***********************************************************************
* SEE IF THE DRIVER IS ACTIVE
***********************************************************************
QFN10600 DS    0H
         TM    SD0FLG1,X'FF'      LOAD CORO STATUS BYTE                 D10939
         BNZ   QFN10605                                                 D10939
         WTOPC TEXT='CORO DRIVER IS NOT ACTIVE, ALTER REJECTED',       X
               NUM=8,LET=E,ROUT=(PRC,RO,RDBS)
         B     EXIT
***********************************************************************
*  LOAD THE ECBS NUMBER TO THE GLOBAL RECORD
***********************************************************************
QFN10605 DS    0H
         L     R1,CE1CR0
         L     R14,12(R1)              LOAD POINTER TO ECBS
         LTR   R14,R14
         BZ    QFN10610
         L     R14,0(14)
         STH   R14,SD0MECB
QFN10610 DS    0H
***********************************************************************
*  LOAD THE NEST NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         L     R14,16(R1)              LOAD POINTER TO NEST
         LTR   R14,R14
         BZ    QFN10620
         L     R14,0(14)
         STH   R14,SD0NEST
QFN10620 DS    0H
***********************************************************************
*  LOAD THE RIAT NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         L     R14,20(R1)              LOAD POINTER TO POOLID
         LTR   R14,R14
         BZ    QFN10640
QFN10630 DS    0H
         CLC   1(3,R14),=C'SDP'  byte 0 is length,
         BNE   QFN10631
         MVC   SD0RIAT,=C'SL'
         B     QFN10640
*
QFN10631 DS    0H
         CLC   1(3,R14),=C'LDP'  byte 0 is length,
         BNE   QFN10632
         MVC   SD0RIAT,=C'LL'
         B     QFN10640
*
QFN10632 DS    0H
         CLC   1(3,R14),=C'4DP'  byte 0 is length,
         BNE   QFN10633
         MVC   SD0RIAT,=X'00E8'
         B     QFN10640
*
QFN10633 DS    0H
         CLC   1(3,R14),=C'SST'  byte 0 is length,
         BNE   QFN10634
         MVC   SD0RIAT,=C'SS'
         B     QFN10640
*
QFN10634 DS    0H
         CLC   1(3,R14),=C'LST'  byte 0 is length,
         BNE   QFN10635
         MVC   SD0RIAT,=C'LS'
         B     QFN10640
*
QFN10635 DS    0H
         MVC   SD0RIAT,=X'00F3'
QFN10640 DS    0H
***********************************************************************
*  LOAD THE FA NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         L     R14,24(R1)              LOAD POINTER TO FA
         LTR   R14,R14
         BNZ   QFN10650
         LA    R14,1                   default FA to 1
         B     QFN10651
         SPACE 1
QFN10650 DS    0H
         L     R14,0(,R14)
QFN10651 DS    0H
         STH   R14,SD0FCNT
***********************************************************************
*  LOAD THE CRETC INTERVAL ->GLOBAL RECORD
***********************************************************************
*
QFN10660 DS    0H
         L     R14,28(R1)              LOAD POINTER TO FA
         LTR   R14,R14
         BNZ   QFN10661
         LA    R14,1                  DEFAULT = 1
         B     QFN10662
         SPACE 1
QFN10661 DS    0H
         L     R14,0(,R14)
QFN10662 DS    0H
         STC   R14,SD0FLG4
***********************************************************************
*  CORE HAS BEEN CHANGED - TELL OPERATOR
***********************************************************************
*
         WTOPC TEXT='CORO DRIVER LEVELS HAVE BEEN ALTERED',            X
               NUM=9,ROUT=(PRC,RO,RDBS)
         B     UNLOCK
         EJECT
***********************************************************************
*
*                     RESET COMMAND
*
***********************************************************************
QFN10700 DS    0H
         MVI   SD0FLG1,X'00'        MARK STOPPED
         MVI   SD0FLG2,X'00'        CLEAR LOCK
         MVI   SD0FLG3,X'00'
         MVI   SD0FLG4,X'00'
         SR    R0,R0
         STH   R0,SD0MECB            CLEAR COUNTS OF MAX    ECBS
         STH   R0,SD0AECB            CLEAR COUNTS OF ACTIVE ECBS
         STH   R0,SD0NEST
         STH   R0,SD0RIAT
         STH   R0,SD0FCNT
         ST    R0,SD0CMT
         ST    R0,SD0RLB
***********************************************************************
* GET A DATA LEVEL 7 IN INIT CR RECORD
***********************************************************************
         GETCC D7,L1,FILL=00        GET A 381 BYTE BLOCK
         MVC   0(4,R14),=X'C3D90000'
***********************************************************************
* INITIALIZE 201 (ORDINAL 0 IS NOT USED)
***********************************************************************
         LA    R2,201
QFN10701 DS    0H
         BAS   R4,INITQL              INITIALIZE QL0QL RECORD
         BCT   R2,QFN10701
         BAS   R4,INITQL              INITIALIZE QL0QL RECORD 0
         WTOPC TEXT='CORO DRIVER RESET COMPLETE',                      X
               NUM=10,ROUT=(PRC,RO,RDBS)
         B     EXIT
         EJECT 1
***********************************************************************
*
*                     VERIFY COMMAND
*
***********************************************************************
*
QFN10800 DS    0H
         LA    R15,0                  SET  ORDINAL NUMBER = 0
*        ST    R15,EBW000             IN EBW000
*        LA    R15,EBW000
*        BAS   R4,GETISN              GET A RAND IS NUMBER
*        LA    R14,4                  PASS 4 BYTES
*        SWISC QFN3,TYPE=CREATE,IS=R5,LIST=#CLHRDY,LEV=NONE
         LA    R14,1
         CRETC S,QFN3,STATE=1052
         B     UNLOCK
         EJECT 1
***********************************************************************
*  GENERATE A RANDOM NUMBER FOR THE 'IS' TO PUT THE WORK ON.
***********************************************************************
GETISN   DS    0H
         DCTIST REG=R3
         CINFC R,CMMIST,F,REG=R3       GET IST ADDR
         SR    R0,R0
         SR    R14,R14
         LH    R0,ISTUSEIS             USABLE I-STREAMS
         STCK  EBW000              STORE CLOCK VALUE
         L     R15,EBW000+4       LOAD CLOCK VALUE
         N     R15,=X'0FFFFFFF'    KEEP NUMBER SMALL
         DR    R14,R0              DIVIDE BY INPUT NUMBER
         LA    R5,1(,R14)         RANDOM NMBR BETWEEN 1 & DIVISOR
         BR    R4
         EJECT  1
***********************************************************************
*  INITIALIZE THE QL0QL RECORD FOR ORDINAL NUMBER PASSED IN R2
***********************************************************************
INITQL   DS    0H
         LR    R0,R2               QL ORDINAL
         LA    R6,=CL8'#QL0QL'
         LA    R7,CE1FA7
         ENTRC FACS
         LTR   R0,R0
         BZ    QLERROR
         MVC   CE1FA7(4),=X'C3D90000'
         FILNC D7
         WAITC QLERROR
         BR    R4
QLERROR  DS    0H
         WTOPC TEXT='CORO DRIVER FIND ERROR ON QL0QL',                 X
               NUM=11,LET=E,ROUT=(PRC,RO,RDBS)
         B     UNLOCK
*
         EJECT  1
***********************************************************************
*  SEIZE THE GLOBAL RECORD, ALL TO MYSELF
***********************************************************************
LOCK     DS    0H
         TS    SD0FLG2
         BZ    LOCKED
         DLAYC ,
         B     LOCK
LOCKED   DS    0H
         BR    R4
*
***********************************************************************
*  UNLOCK THE GLOBAL RECORD AND EXIT
***********************************************************************
UNLOCK   DS    0H
         MVI   SD0FLG2,X'00'
EXIT     DS    0H
         EXITC
         EJECT
***********************************************************************
*  DISPLAY SCREENS FORMATS
***********************************************************************
*
DISP1   DC AL1(DISP1E-DISP1-1)
        DC C'CORO DRIVER IS RUNNING ',AL1(#CAR)
        DC AL1(#CAR)
        DC C'REQUESTED ECBS=... NEST=... RIAT=.... FA=... CRETC=..'
        DC AL1(#CAR)
        DC C'RUNNING ECBS  =... '
        DC AL1(#CAR)
        DC C'TOTAL COMMITS   = ..........'
        DC AL1(#CAR)
        DC C'TOTAL ROLLBACKS = ..........'
        DC AL1(#CAR)
DISP1E  EQU *
*
DISP2   DC AL1(DISP2E-DISP2-1)
        DC C'CORO DRIVER IS STOPPING',AL1(#CAR)
        DC C'RUNNING ECBS=... ',AL1(#CAR)
DISP2E  EQU *
        DS  0D
         LTORG
         FINIS
         END
