         PRINT NOGEN
         BEGIN NAME=QFN2,IBM=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*        URFER      TD00702  092496 CREATE BASE FILE                  *
*        URFER      TD00712  120296 ADD VERIFY OPTION                 *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
***********************************************************************
*
* MODULE NAME..... QFN2
* DESCRIPTION..... COMMIT SYSTEM TEST DRIVER
* RELATED MODULE.. QFN1 MONITOR SEGMENT
*                  QNF3 CORO PROGRAM
* DOCUMENT NAME... CORO DRIVER USERS GUIDE
* LEVEL........... N/A
*
* FUNCTION...      THIS IS A GENERAL PURPOSE COMMIT/ROLLBACK DRIVER
*
*                  THIS IS THE COMMAND PARSER
*
* MODULE ATTRIBUTES..
*   TYPE.......... 'E' (ECB CONTROLLED)
*   DEPENDENCY.... NONE (OBJECT SHIPPABLE)
*   ENVIRONMENT... BASE, BSS
*   ENTRY POINT... QFN2  (ENTNC FROM CVZZ)
*
* ECB-CONVENTIONS.......
*
*   WORK AREA
*
* DATA LEVELS
*         NONE USED
*
* REGISTER-CONVENTIONS..
*
***********************************************************************
*
* TO USE...... QFN2 IS INVOKED VIA ZTEST COMMAND.
*
*        ZTEST CORO CMD
*
*              CMD  =ACTION CODE
*                       START
*                       ALTER
*                       STOP
*                       STATUS
*                       VERIFY
         EJECT 1
***********************************************************************
* DSECTS
***********************************************************************
         DCTBPK REG=R6            MAP BPKDC OUTPUT LIST
*
         B     QFN20000
         DC    CL8'&SYSDATE',CL1' ',CL8'&SYSTIME'
*
QFN20000 DS    0H
***********************************************************************
* PARSE MESSAGE AND let it sit on data level 0
***********************************************************************
         BPKDC EXECUTE=YES,BPKD=MAINBPK,HELP=QFN29995,ERROR=QFN29995,  X
               EMSG=Y
***********************************************************************
*        goto the right routine
***********************************************************************
         L     R6,CE1CR0          PROCESS MAINLINE COMMAND
         L     R7,ACTION
         B     QFN20100(R7)       GO TO INDICATED ROUTINE
         SPACE 2
*
QFN20100 DS    0H                 BRANCH TABLE FOR CMDS
         B     QFN29995           INVALID INDEX GENERATED
         B     QFN20200           ACTION IS 'START'
         B     QFN20300           ACTION IS 'STOP'
         B     QFN20400           ACTION IS 'STATUS'
         B     QFN20500           ACTION IS 'ALTER'
         B     QFN20600           ACTION IS 'ONCE'
         B     QFN20700           ACTION IS 'RESET'
         B     QFN20800           ACTION IS 'VERIFY'
         SPACE 2
         EJECT 1
***********************************************************************
*
*  START COMMAND
*
***********************************************************************
QFN20200 DS    0H                 CORO 'START COMMAND
         L     R14,POOLS
         LTR   R14,R14
         BZ    QFN20210
***********************************************************************
* VALIDATE THE POOLID PARAMETER
***********************************************************************
         CLC   1(3,R14),=C'SDP'
         BE    QFN20210
         CLC   1(3,R14),=C'LDP'
         BE    QFN20210
         CLC   1(3,R14),=C'4DP'
         BE    QFN20210
         CLC   1(3,R14),=C'SST'
         BE    QFN20210
         CLC   1(3,R14),=C'LST'
         BE    QFN20210
         CLC   1(3,R14),=C'4ST'
         BE    QFN20210
         LA    R2,QFN2M06
         BAS   R4,QFN2WTPC
         B     QFN29999
***********************************************************************
* VALIDATE THE FA PARAMETER
***********************************************************************
QFN20210 DS    0H
         L     R14,24(R6)              LOAD POINTER TO FA
         LTR   R14,R14
         BZ    QFN20215
         L     R14,0(,R14)
         C     R14,=F'200'
         BH    QFN20220
***********************************************************************
* INPUT VALUES ARE OK, GO TO START
***********************************************************************
QFN20215 DS    0H
         MVC   EBW000(4),=C'STAR'
         LA    R2,QFN2M01
         BAS   R4,QFN2WTPC
         ENTNC QFN1               GO TO POLICE
***********************************************************************
* INVALID FA ADDRESS GIVEN . WTOPC AND EXIT
***********************************************************************
QFN20220 DS    0H
         LA    R2,QFN2M08
         BAS   R4,QFN2WTPC
         B     QFN29999
         EJECT 1
***********************************************************************
*
*  STOP  COMMAND
*
***********************************************************************
QFN20300 DS    0H                 CORO 'STOP' COMMAND
         MVC   EBW000(4),=C'STOP'
         ENTNC QFN1               GO TO POLICE
         EJECT 1
***********************************************************************
*
*  STATUS COMMAND
*
***********************************************************************
QFN20400 DS    0H                 CORO 'STATUS COMMAND
         MVC   EBW000(4),=C'STAT'
         ENTNC QFN1               GO TO POLICE
         SPACE 2
         EJECT 1
***********************************************************************
*
*  ALTER COMMAND
*
***********************************************************************
QFN20500 DS    0H
         L     R14,POOLS
         LTR   R14,R14
         BZ    QFN20510
***********************************************************************
* VALIDATE THE POOLID PARAMETER
***********************************************************************
         CLC   1(3,R14),=C'SDP'
         BE    QFN20510
         CLC   1(3,R14),=C'LDP'
         BE    QFN20510
         CLC   1(3,R14),=C'4DP'
         BE    QFN20510
         CLC   1(3,R14),=C'SST'
         BE    QFN20510
         CLC   1(3,R14),=C'LST'
         BE    QFN20510
         CLC   1(3,R14),=C'4ST'
         BE    QFN20510
***********************************************************************
* BAD POOLID PARAMETER GIVEN
***********************************************************************
         LA    R2,QFN2M06
         BAS   R4,QFN2WTPC
         B     QFN29999
***********************************************************************
* VALIDATE THE FA PARAMETER
***********************************************************************
QFN20510 DS    0H
         L     R14,24(R6)              LOAD POINTER TO FA
         LTR   R14,R14
         BZ    QFN20515
         L     R14,0(,R14)
         C     R14,=F'200'
         BH    QFN20220
***********************************************************************
* INPUT VAULES ARE OK GO TO ALTER
***********************************************************************
QFN20515 DS    0H
         MVC   EBW000(4),=C'ALTE'
         ENTNC QFN1               GO TO POLICE
         EJECT 1
***********************************************************************
*
*  ONCE  COMMAND
*
***********************************************************************
QFN20600 DS    0H
         L     R14,POOLS
         LTR   R14,R14
         BZ    QFN20610
***********************************************************************
* VALIDATE POOLID PARAMETER
***********************************************************************
         CLC   1(3,R14),=C'SDP'
         BE    QFN20610
         CLC   1(3,R14),=C'LDP'
         BE    QFN20610
         CLC   1(3,R14),=C'4DP'
         BE    QFN20610
         CLC   1(3,R14),=C'SST'
         BE    QFN20610
         CLC   1(3,R14),=C'LST'
         BE    QFN20610
         CLC   1(3,R14),=C'4ST'
         BE    QFN20610
***********************************************************************
* BAD POOLID GIVEN
***********************************************************************
         LA    R2,QFN2M06
         BAS   R4,QFN2WTPC
         B     QFN29999
***********************************************************************
* VALIDATE THE FA PARAMETER
***********************************************************************
QFN20610 DS    0H
         L     R14,28(R6)              LOAD POINTER TO FA
         LTR   R14,R14
         BZ    QFN20615
         L     R14,0(,R14)
         C     R14,=F'200'
         BH    QFN20220
***********************************************************************
* INPUT VAULES ARE OK GO TO DO ONCE
***********************************************************************
QFN20615 DS    0H
         MVC   EBW000(4),=C'ONCE'
         LA    R2,QFN2M05
         BAS   R4,QFN2WTPC
         ENTNC QFN1               GO TO POLICE
         EJECT 1
***********************************************************************
*
*  RESET COMMAND
*
***********************************************************************
QFN20700 DS    0H
         LA    R2,QFN2M04
         BAS   R4,QFN2WTPC
         MVC   EBW000(4),=C'RESE'
         ENTNC QFN1               GO TO POLICE
         EJECT 1
***********************************************************************
*
*  VERIFY COMMAND
*
***********************************************************************
QFN20800 DS    0H
         MVC   EBW000(4),=C'VERI'
         LA    R2,QFN2M07
         BAS   R4,QFN2WTPC
         ENTNC QFN1               GO TO POLICE
***********************************************************************
*
*  HELP  COMMAND
*
***********************************************************************
QFN29995 DS    0H                 CORO 'HELP' COMMAND
         LA    R2,HELPSCR
         BAS   R4,QFN2HELP
         B     QFN29999           CONTINUE ON OTHERWISE
         SPACE 1
***********************************************************************
*
*  EXIT
*
***********************************************************************
QFN29999 DS    0H
         CRUSA S0=2,S1=3
         EXITC ,
         EJECT 1
*
*  Messages
*
QFN2M01  GENMSG LET=I,NUM=01,TEXT='CORO DRIVER IS STARTING'
QFN2M04  GENMSG LET=I,NUM=04,TEXT='CORO DRIVER RESET BEGUN'
QFN2M05  GENMSG LET=I,NUM=05,TEXT='CORO DRIVER IS RUNNING ONCE'
QFN2M06  GENMSG LET=E,NUM=06,TEXT='INVALID POOLID VALUE GIVEN'
QFN2M07  GENMSG LET=I,NUM=07,TEXT='CORO DRIVER IS VERIFYING:'
QFN2M08  GENMSG LET=E,NUM=08,TEXT='INVALID FA VALUE. 200 MAX'
*
*  Skeleton WTOPC macros
*
         DCTMSG
         USING DCTMSG,R2
QFN2WTPC WTOPC PREFIX=QFN2,CHAIN=YES,ENDOFM=YES,                       X
               NUMA=MSGNUM,                                            X
               LETA=MSGLET,                                            X
               TEXTA=MSGLEN,                                           X
               COMP=YES,                                               X
               ROUT=(PRC,RO,RDBS)
         DROP  R2
         BR    R4
*
QFN2HELP WTOPC PREFIX=QFN2,CHAIN=YES,ENDOFM=YES,                       X
               TEXTA=(R2),                                             X
               COMP=YES,                                               X
               NUM=100,                                                X
               ROUT=(PRC,RO,RDBS)
         BR    R4
*
         EJECT 1
MAINBPK  BPKDC (PSR,ACTION,ACTBPP)
         SPACE 2
ACTBPP   BPPSC (START,4,STRTBPK),                                      X
               (STOP,3),                                               X
               (STATUS,4),                                             X
               (ALTER,1,STRTBPK),                                      X
               (ONCE,1,ONCEBPK),                                       X
               (RESET,1),                                              X
               (VERIFY,1)
         SPACE 2
STRTBPK  BPKDC (PSR,ACTION,ACTBPP),                                    X
               (KD,ECB,1,3),                                           X
               (KD,NEST,1,3),                                          X
               (KC,POOLID,1,3),                                        X
               (KD,FA,1,3),                                            X
               (KD,CRETC,1,2)
ONCEBPK  BPKDC (PSR,ACTION,ACTBPP),                                    X
               (KD,ECB,1,3),                                           X
               (KD,NEST,1,3),                                          X
               (KC,POOLID,2,3),                                        X
               (KC,PRT,2,1),                                           X
               (KD,FA,1,3)
*
         DS    0D
HELPSCR  DC    AL1(HELPEND-*-1)
         DC    C'ZTEST CORO cmd  ',AL1(#CAR)
         DC    C' where cmd is:',AL1(#CAR)
         DC    C' STARt Ecb=N Nest=N Poolid=C Fa=N Cretc=N',AL1(#CAR)
         DC    C' Alter Ecb=N Nest=N Poolid=C Fa=N',AL1(#CAR)
         DC    C' Once  Ecb=N Nest=N Poolid=C PRt=Y',AL1(#CAR)
         DC    C' STATus',AL1(#CAR)
         DC    C' STOp',AL1(#CAR)
         DC    C' Reset',AL1(#CAR)
         DC    C' Verify',AL1(#CAR)
         DC    AL1(#CAR)
         DC    C'WHERE N IS A 3-DIGIT NUMBER',AL1(#CAR)
         DC    C'WHERE C IS SDP LDP 4DP SST LST 4ST',AL1(#CAR)
HELPEND  EQU *
*
*
*
*  ASSIGN MEANINGFUL NAMES TO THE LABELS GENERATED BY BPKDC
*
ACTION   EQU   BPKOPM1
ECBS     EQU   BPKOPM2
NESTS    EQU   BPKOPM3
POOLS    EQU   BPKOPM4
FA1      EQU   BPKOPM5
PRT      EQU   BPKOPM5
FA2      EQU   BPKOPM6
         LTORG
         FINIS QFN2
         END   ,
