         PRINT NOGEN
         BEGIN NAME=QMS0,AMODE=64,IBM=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
***********************************************************************
*
*   MODULE NAME..... QMS0 START/STOP PROCESSING
*   RELATED MODULE.. QMS2 TO PERFORM COMMITS/ROLLBACKS
*   DESCRIPTION..... CONTROL STARTING AND STOPPING OF CORO DRIVER
*   LEVEL........... VERSION 1  MODIFICATION 0
*
*   FUNCTION... QMS0 IS DIVIDED INTO  FUNCTIONS -
*                     STARTING THE DRIVER
*                     STOPPING THE DRIVER
*                     DISPLAY THE STATUS
*                     MAINTAIN THE ACTIVITY LEVELS
***********************************************************************
         EJECT
***********************************************************************
*   JUMP AROUND TIMESTAMP
***********************************************************************
         J     QXRMJUMP                                                 64MODE
         DC    CL8'&SYSDATE',CL1' ',CL8'&SYSTIME'
***********************************************************************
*   BRANCH TABLE
***********************************************************************
QXRMJUMP DS    0H
         SD0RV REG=R6                  I-S SHARED DRIVER GLOB REC
         GLOBZ REGR=R14
***********************************************************************
* PROCESS COMMAND
***********************************************************************
         LLGF  R6,@ISSDRV              GET ADDRS TO I-S SHARED GLOBAL   64MODE
* NON LOCKED COMMANDS
         CLC   EBW000(4),=C'STAT'      STATUS REQUEST
         JE    QFN10300                                                 64MODE
         CLC   EBW000(4),=C'RESE'      RESET REQUEST
         JE    QFN10700                                                 64MODE
* LOCKED COMMANDS
         BRAS  R4,LOCK                 LOCK THE GLOBAL RECORD           64MODE
         CLC   EBW000(4),=C'STAR'      START REQUEST
         JE    QFN10000                                                 64MODE
         CLC   EBW000(4),=C'CRET'      RUNNING MODE
         JE    QFN10100                                                 64MODE
         CLC   EBW000(4),=C'STOP'      STOP REQUEST
         JE    QFN10200                                                 64MODE
         CLC   EBW000(4),=C'DONE'      LOOK TO SEE IF WE ARE DONE
         JE    QFN10400                                                 64MODE
         CLC   EBW000(4),=C'ONCE'      ONCE CMD
         JE    QFN10500                                                 64MODE
         CLC   EBW000(4),=C'ALTE'      ALTER REQUEST
         JE    QFN10600                                                 64MODE
         CLC   EBW000(4),=C'VERI'      VERIFY REQUEST
         JE    QFN10800                                                 64MODE
         J     UNLOCK                                                   64MODE
         EJECT
***********************************************************************
*
*                     START COMMAND
*
***********************************************************************
*
QFN10000 DS    0H
         TM    SD0FLG1,X'FF'           IS IT RUNNING
         JZ    QFN10001                                                 64MODE
         WTOPC TEXT='CORO64 DRIVER IS ALREADY ACTIVE, START REJECTED', X
               NUM=1,LET=E,ROUT=(PRC,RO,RDBS)
         J     UNLOCK                                                   64MODE
***********************************************************************
*  LOAD THE ECBS NUMBER TO THE GLOBAL RECORD
***********************************************************************
QFN10001 DS    0H
         NI    SD0FLG3,255-SD03PRT     turn off prt flag
         LLGF  R1,CE1CR0                                                64MODE
         LGF   R14,12(R1)              LOAD POINTER TO ECBS             64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10005                                                 64MODE
         LGHI  R14,1                   default ECB= to 1                64MODE
         J     QFN10010                                                 64MODE
         SPACE 1
QFN10005 DS    0H
         LLGF  R14,0(,R14)                                              64MODE
QFN10010 DS    0H
         STH   R14,SD0MECB
***********************************************************************
*  LOAD THE NEST NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         LGF   R14,16(R1)              LOAD POINTER TO NEST             64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10015                                                 64MODE
         LGHI  R14,3                   default nesting= to 3            64MODE
         J     QFN10020                                                 64MODE
         SPACE 1
QFN10015 DS    0H
         LLGF  R14,0(,R14)             nesting level default is 3       64MODE
QFN10020 DS    0H
         STH   R14,SD0NEST
***********************************************************************
*  LOAD THE RIAT NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         LGF   R14,20(R1)              LOAD POINTER TO RIAT             64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10030                                                 64MODE
         MVC   SD0RIAT,=C'LL'
         J     QFN10040                                                 64MODE
QFN10030 DS    0H
         CLC   1(3,R14),=C'SDP'  byte 0 is length,
         JNE   QFN10031                                                 64MODE
         MVC   SD0RIAT,=C'SL'
         J     QFN10040                                                 64MODE
*
QFN10031 DS    0H
         CLC   1(3,R14),=C'LDP'  byte 0 is length,
         JNE   QFN10032                                                 64MODE
         MVC   SD0RIAT,=C'LL'
         J     QFN10040                                                 64MODE
*
QFN10032 DS    0H
         CLC   1(3,R14),=C'4DP'  byte 0 is length,
         JNE   QFN10033                                                 64MODE
         MVC   SD0RIAT,=X'00E8'
         J     QFN10040                                                 64MODE
*
QFN10033 DS    0H
         CLC   1(3,R14),=C'SST'  byte 0 is length,
         JNE   QFN10034                                                 64MODE
         MVC   SD0RIAT,=C'SS'
         J     QFN10040                                                 64MODE
*
QFN10034 DS    0H
         CLC   1(3,R14),=C'LST'  byte 0 is length,
         JNE   QFN10035                                                 64MODE
         MVC   SD0RIAT,=C'LS'
         J     QFN10040                                                 64MODE
*
QFN10035 DS    0H
         MVC   SD0RIAT,=X'00F3'
***********************************************************************
*  LOAD THE FA NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
QFN10040 DS    0H
         LGF   R14,24(R1)              LOAD POINTER TO FA               64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10050                                                 64MODE
         LGHI  R14,1                   default FA to 1                  64MODE
         J     QFN10051                                                 64MODE
         SPACE 1
QFN10050 DS    0H
         LLGF  R14,0(,R14)                                              64MODE
QFN10051 DS    0H
         STH   R14,SD0FCNT
***********************************************************************
*  LOAD THE CRETC INTERVAL ->GLOBAL RECORD
***********************************************************************
*
QFN10060 DS    0H
         LGF   R14,28(R1)              LOAD POINTER TO FA               64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10061                                                 64MODE
         LGHI  R14,1                  DEFAULT = 1                       64MODE
         J     QFN10062                                                 64MODE
         SPACE 1
QFN10061 DS    0H
         LLGF  R14,0(,R14)                                              64MODE
QFN10062 DS    0H
         STC   R14,SD0FLG4
***********************************************************************
* MARK CORO AS BEING ACTIVE AND EXIT IF STARTING THE DRIVER ELSE EXIT
***********************************************************************
*
         MVI   SD0FLG1,X'F0'           MARK CORO AS BEING ACTIVE
         LGHI  R14,1                   CRET BACK TO SELF IN 1  SECONDS  64MODE
         LLGF  R15,=C'CRET'            MARK ECB AS A CRET ECB           64MODE
         CRETC S,QMS0,STATE=1052
QFN10070 DS 0H
         J     UNLOCK                                                   64MODE
         EJECT
***********************************************************************
*
*                     CRET COMMAND
*
***********************************************************************
*
*  IF CORO IS NOT ACTIVE, EXIT
*
QFN10100 DS    0H
         NI    SD0FLG3,255-SD03PRT     turn off prt flag
         TM    SD0FLG1,X'F0'            LOAD CORO STATUS BYTE
         JO    QFN10110                CORO IS ACTIVE, KEEP GOING       64MODE
         J     UNLOCK                  CORO IS NOT ACTIVE, QUIT         64MODE
***********************************************************************
*  CREATE SOME ECBS
***********************************************************************
QFN10110 DS    0H
         SGR   R2,R2                  CLEAR R2                          64MODE
         SGR   R1,R1                  CLEAR R1                          64MODE
         LGH   R2,SD0MECB             GET COUNT OF MAX ECBS             64MODE
         LGH   R1,SD0AECB             GET COUNT OF ECBS RUNNING         64MODE
         SGR   R2,R1                  NUMBER TO CREATE                  64MODE
         JNH   QFN10191               IF = 0 THEN SKIP                  64MODE
*
QFN10120 DS    0H                     CREATE A CORO ECB
         LGR   R15,R2                 PASS ORDINAL NUMBER               64MODE
*        ST    R15,EBW000             IN EBW000
*        LA    R15,EBW000
*        BAS   R4,GETISN              GET A RAND IS NUMBER
*        LA    R14,4                  PASS 4 BYTES
*        SWISC QFN3,TYPE=CREATE,IS=R5,LIST=#CLHRDY,LEV=NONE
         LGH   R1,SD0AECB             GET COUNT OF ECBS RUNNING         64MODE
         AGHI  R1,1                   ADD ONE TO IT                     64MODE
         STH   R1,SD0AECB             STORE IT
* Because of timimg issues, increment AECB count >before< calling QMS2
         LGHI  R14,1                                                    D10621
         CRETC S,QMS2,STATE=1052                                        D10621
         BRCTG R2,QFN10120                                              64MODE
***********************************************************************
* CRET BACK TO SELF LATER
***********************************************************************
QFN10191 DS    0H
         SGR   R14,R14                                                  64MODE
         IC    R14,SD0FLG4         GET TIME FROM GLOBAL FIELD
         LLGF  R15,=C'CRET'                                             64MODE
         CRETC S,QMS0,STATE=1052
         J     UNLOCK                                                   64MODE
         EJECT
*******************************************************************
*
*                     STOP COMMAND
*
*******************************************************************
QFN10200 DS    0H
         TM    SD0FLG1,X'F0'      LOAD CORO STATUS BYTE
         JO    QFN10210                                                 64MODE
         WTOPC TEXT='CORO64 DRIVER IS NOT ACTIVE, STOP REJECTED',      X
               NUM=2,LET=E,ROUT=(PRC,RO,RDBS)
         J     UNLOCK                                                   64MODE
***********************************************************************
*
* MARK STOP IN PROGRESS FIELD
*
***********************************************************************
QFN10210 DS    0H
         MVI   SD0FLG1,X'0F'        STOP CREATING ECBS
         SGR   R0,R0                                                    64MODE
         STH   R0,SD0MECB            CLEAR COUNTS OF MAX    ECBS
         WTOPC TEXT='CORO64 DRIVER IS NOW STOPPING',                   X
               NUM=3,ROUT=(PRC,RO,RDBS)
         LGHI  R14,1                                                    64MODE
         LLGF  R15,=C'DONE'                         GO INTO WATCH MODE  64MODE
         CRETC S,QMS0,STATE=1052
         J     UNLOCK                                                   64MODE
         EJECT 1
*******************************************************************
*
*                     STAT COMMAND
*
*******************************************************************
QFN10300 DS    0H
         MVI   SD0FLG2,X'00'           JUST LOOKING THANK YOU
         TM    SD0FLG1,X'F0'          LOAD CORO STATUS BYTE
         JO    QFN10320                DRIVER IS ACTIVE                 64MODE
***********************************************************************
* DRIVER IS NOT ACTIVE
***********************************************************************
         TM    SD0FLG1,X'0F'      LOAD CORO STATUS BYTE
         JO    QFN10310                                                 64MODE
         WTOPC TEXT='CORO64 DRIVER IS NOT ACTIVE',                     X
               NUM=4,ROUT=(PRC,RO,RDBS)
         J     EXIT                                                     64MODE
***********************************************************************
* DRIVER IS STOPPING  BUT NOT DEAD YET
***********************************************************************
QFN10310 DS    0H
         SGR   R2,R2                                                    64MODE
         LGH   R2,SD0AECB                                               64MODE
         WTOPC TEXTA=DISP2,NUM=5,ROUT=(PRC,RO,RDBS),                   X
               SUB=(DEC,(R2))
         J     EXIT                                                     64MODE
***********************************************************************
* DRIVER IS ACTIVE
***********************************************************************
QFN10320 DS    0H
         SGR   R2,R2                                                    64MODE
         LGH   R2,SD0AECB                                               64MODE
         SGR   R3,R3                                                    64MODE
         LGH   R3,SD0MECB                                               64MODE
         SGR   R4,R4                                                    64MODE
         LGH   R4,SD0NEST                                               64MODE
         SGR   R5,R5                                                    64MODE
         LGH   R5,SD0FCNT                                               64MODE
         SGR   R7,R7                                                    64MODE
         IC    R7,SD0FLG4              GET THE CRETC TIME IN R7
         WTOPC TEXTA=DISP1,NUM=6,ROUT=(PRC,RO,RDBS),                   X
               SUB=(DEC,(R3),DEC,(R4),HEX4A,SD0RIAT,DEC,(R5),          X
               DEC,(R7),DEC,(R2),DECA,SD0CMT,DECA,SD0RLB)
         J     EXIT                                                     64MODE
         EJECT 1
***********************************************************************
*
*                     DONE COMMAND
*
***********************************************************************
QFN10400 DS    0H
***********************************************************************
*  CHECK ADD ECBS
***********************************************************************
QFN10410 DS    0H
         LGH   R1,SD0AECB             GET COUNT OF ECBS RUNNING         64MODE
         LTGR  R1,R1                                                    64MODE
         JNZ   QFN10490               STILL RUNNING                     64MODE
***********************************************************************
* DRIVER IS DEAD TELL OPERATOR
***********************************************************************
         WTOPC TEXT='CORO64 DRIVER IS NOW STOPPED',                    X
               NUM=7,ROUT=(PRC,RO,RDBS)
         MVI   SD0FLG1,X'00'        MARK STOPPED
         MVI   SD0FLG2,X'00'        MARK STOPPED
         MVI   SD0FLG3,X'00'        MARK STOPPED
         MVI   SD0FLG4,X'00'        MARK STOPPED
         SGR   R0,R0                                                    64MODE
         STH   R0,SD0MECB            CLEAR COUNTS OF MAX    ECBS
         STH   R0,SD0NEST
         STH   R0,SD0RIAT
         ST    R0,SD0CMT
         ST    R0,SD0RLB
         STH   R0,SD0FCNT
         J     EXIT                                                     64MODE
***********************************************************************
* DRIVER IS STILL RUNNING, KEEP CHECKING
***********************************************************************
QFN10490 DS    0H
         LGHI  R14,3                       LOOK EVERY THREE SECONDS     64MODE
         LLGF  R15,=C'DONE'                                             64MODE
         CRETC S,QMS0,STATE=1052
         J     UNLOCK                                                   64MODE
         EJECT
***********************************************************************
*
*                     ONCE  COMMAND
*
***********************************************************************
*
         SPACE 1
QFN10500 DS    0H
         MVI   SD0FLG2,X'00'        UNLOCK DRIVER
         LLGF  R1,CE1CR0                                                64MODE
***********************************************************************
*  LOAD THE NEST NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         LGF   R14,16(R1)              LOAD POINTER TO NEST             64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10515                                                 64MODE
         LGHI  R14,3                   default nesting= to 3            64MODE
         J     QFN10520                                                 64MODE
         SPACE 1
QFN10515 DS    0H
         LLGF  R14,0(,R14)             nesting level default is 3       64MODE
QFN10520 DS    0H
         STH   R14,SD0NEST
***********************************************************************
*  LOAD THE RIAT NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         LGF   R14,20(R1)              LOAD POINTER TO RIAT             64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10530                                                 64MODE
         MVC   SD0RIAT,=C'LL'
         J     QFN10540                                                 64MODE
QFN10530 DS    0H
         CLC   1(3,R14),=C'SDP'  byte 0 is length,
         JNE   QFN10531                                                 64MODE
         MVC   SD0RIAT,=C'SL'
         J     QFN10540                                                 64MODE
*
QFN10531 DS    0H
         CLC   1(3,R14),=C'LDP'  byte 0 is length,
         JNE   QFN10532                                                 64MODE
         MVC   SD0RIAT,=C'LL'
         J     QFN10540                                                 64MODE
*
QFN10532 DS    0H
         CLC   1(3,R14),=C'4DP'  byte 0 is length,
         JNE   QFN10533                                                 64MODE
         MVC   SD0RIAT,=X'00E8'
         J     QFN10540                                                 64MODE
*
QFN10533 DS    0H
         CLC   1(3,R14),=C'SST'  byte 0 is length,
         JNE   QFN10534                                                 64MODE
         MVC   SD0RIAT,=C'SS'
         J     QFN10540                                                 64MODE
*
QFN10534 DS    0H
         CLC   1(3,R14),=C'LST'  byte 0 is length,
         JNE   QFN10535                                                 64MODE
         MVC   SD0RIAT,=C'LS'
         J     QFN10540                                                 64MODE
*
QFN10535 DS    0H
         MVC   SD0RIAT,=X'00F3'
*
***********************************************************************
*  LOAD THE PRT FLAG TO THE GLOBAL RECORD
***********************************************************************
*
QFN10540 DS    0H
         NI    SD0FLG3,255-SD03PRT     turn off prt flag
         LGF   R14,24(R1)              LOAD POINTER TO PRT              64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN10550                                                 64MODE
         CLI   1(R14),C'Y'             prt=Y ?
         JNE   QFN10550                                                 64MODE
QFN10545 DS    0H
         OI    SD0FLG3,SD03PRT         turn on prt flag
***********************************************************************
*  LOAD THE FA NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
QFN10550 DS    0H
         LGF   R14,28(R1)              LOAD POINTER TO FA               64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10560                                                 64MODE
         LGHI  R14,1                   default FA to 1                  64MODE
         J     QFN10561                                                 64MODE
         SPACE 1
QFN10560 DS    0H
         LLGF  R14,0(,R14)                                              64MODE
QFN10561 DS    0H
         STH   R14,SD0FCNT
***********************************************************************
* RUN CORO JUST ONCE WITH NEST AND POOLID SUPPLIED
***********************************************************************
*
         LGH   R1,SD0AECB             GET COUNT OF ECBS RUNNING         64MODE
         AGHI  R1,1                   ADD ONE TO IT                     64MODE
         STH   R1,SD0AECB             STORE IT
         LGHI  R15,1                  SET  ORDINAL NUMBER = 1           64MODE
*        ST    R15,EBW000             IN EBW000
*        LA    R15,EBW000
*        BAS   R4,GETISN              GET A RAND IS NUMBER
*        LA    R14,4                  PASS 4 BYTES
*        SWISC QFN3,TYPE=CREATE,IS=R5,LIST=#CLHRDY,LEV=NONE
         LGHI  R14,1                                                    64MODE
         CRETC S,QMS2,STATE=1052
         J     UNLOCK                                                   64MODE
         SPACE 1
***********************************************************************
*
*                     ALTER COMMAND
*
***********************************************************************
*
***********************************************************************
* SEE IF THE DRIVER IS ACTIVE
***********************************************************************
QFN10600 DS    0H
         TM    SD0FLG1,X'F0'      LOAD CORO STATUS BYTE
         JO    QFN10605                                                 64MODE
         WTOPC TEXT='CORO64 DRIVER IS NOT ACTIVE, ALTER REJECTED',     X
               NUM=8,LET=E,ROUT=(PRC,RO,RDBS)
         J     EXIT                                                     64MODE
***********************************************************************
*  LOAD THE ECBS NUMBER TO THE GLOBAL RECORD
***********************************************************************
QFN10605 DS    0H
         LLGF  R1,CE1CR0                                                64MODE
         LGF   R14,12(R1)              LOAD POINTER TO ECBS             64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN10610                                                 64MODE
         LLGF  R14,0(14)                                                64MODE
         STH   R14,SD0MECB
QFN10610 DS    0H
***********************************************************************
*  LOAD THE NEST NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         LGF   R14,16(R1)              LOAD POINTER TO NEST             64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN10620                                                 64MODE
         LLGF  R14,0(14)                                                64MODE
         STH   R14,SD0NEST
QFN10620 DS    0H
***********************************************************************
*  LOAD THE RIAT NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         LGF   R14,20(R1)              LOAD POINTER TO POOLID           64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN10640                                                 64MODE
QFN10630 DS    0H
         CLC   1(3,R14),=C'SDP'  byte 0 is length,
         JNE   QFN10631                                                 64MODE
         MVC   SD0RIAT,=C'SL'
         J     QFN10640                                                 64MODE
*
QFN10631 DS    0H
         CLC   1(3,R14),=C'LDP'  byte 0 is length,
         JNE   QFN10632                                                 64MODE
         MVC   SD0RIAT,=C'LL'
         J     QFN10640                                                 64MODE
*
QFN10632 DS    0H
         CLC   1(3,R14),=C'4DP'  byte 0 is length,
         JNE   QFN10633                                                 64MODE
         MVC   SD0RIAT,=X'00E8'
         J     QFN10640                                                 64MODE
*
QFN10633 DS    0H
         CLC   1(3,R14),=C'SST'  byte 0 is length,
         JNE   QFN10634                                                 64MODE
         MVC   SD0RIAT,=C'SS'
         J     QFN10640                                                 64MODE
*
QFN10634 DS    0H
         CLC   1(3,R14),=C'LST'  byte 0 is length,
         JNE   QFN10635                                                 64MODE
         MVC   SD0RIAT,=C'LS'
         J     QFN10640                                                 64MODE
*
QFN10635 DS    0H
         MVC   SD0RIAT,=X'00F3'
QFN10640 DS    0H
***********************************************************************
*  LOAD THE FA NUMBER TO THE GLOBAL RECORD
***********************************************************************
*
         LGF   R14,24(R1)              LOAD POINTER TO FA               64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10650                                                 64MODE
         LGHI  R14,1                   default FA to 1                  64MODE
         J     QFN10651                                                 64MODE
         SPACE 1
QFN10650 DS    0H
         LLGF  R14,0(,R14)                                              64MODE
QFN10651 DS    0H
         STH   R14,SD0FCNT
***********************************************************************
*  LOAD THE CRETC INTERVAL ->GLOBAL RECORD
***********************************************************************
*
QFN10660 DS    0H
         LGF   R14,28(R1)              LOAD POINTER TO FA               64MODE
         LTGR  R14,R14                                                  64MODE
         JNZ   QFN10661                                                 64MODE
         LGHI  R14,1                  DEFAULT = 1                       64MODE
         J     QFN10662                                                 64MODE
         SPACE 1
QFN10661 DS    0H
         LLGF  R14,0(,R14)                                              64MODE
QFN10662 DS    0H
         STC   R14,SD0FLG4
***********************************************************************
*  CORE HAS BEEN CHANGED - TELL OPERATOR
***********************************************************************
*
         WTOPC TEXT='CORO64 DRIVER LEVELS HAVE BEEN ALTERED',          X
               NUM=9,ROUT=(PRC,RO,RDBS)
         J     UNLOCK                                                   64MODE
         EJECT
***********************************************************************
*
*                     RESET COMMAND
*
***********************************************************************
QFN10700 DS    0H
         MVI   SD0FLG1,X'00'        MARK STOPPED
         MVI   SD0FLG2,X'00'        CLEAR LOCK
         MVI   SD0FLG3,X'00'
         MVI   SD0FLG4,X'00'
         SGR   R0,R0                                                    64MODE
         STH   R0,SD0MECB            CLEAR COUNTS OF MAX    ECBS
         STH   R0,SD0AECB            CLEAR COUNTS OF ACTIVE ECBS
         STH   R0,SD0NEST
         STH   R0,SD0RIAT
         STH   R0,SD0FCNT
         ST    R0,SD0CMT
         ST    R0,SD0RLB
***********************************************************************
* GET A DATA LEVEL 7 IN INIT CR RECORD
***********************************************************************
         GETCC D7,L1,FILL=00        GET A 381 BYTE BLOCK
         MVC   0(4,R14),=X'C3D90000'
***********************************************************************
* INITIALIZE 201 (ORDINAL 0 IS NOT USED)
***********************************************************************
         LGHI  R2,201                                                   64MODE
QFN10701 DS    0H
         BRAS  R4,INITQL              INITIALIZE QL0QL RECORD           64MODE
         BRCTG R2,QFN10701                                              64MODE
         BRAS  R4,INITQL              INITIALIZE QL0QL RECORD 0         64MODE
         WTOPC TEXT='CORO64 DRIVER RESET COMPLETE',                    X
               NUM=10,ROUT=(PRC,RO,RDBS)
         J     EXIT                                                     64MODE
         EJECT 1
***********************************************************************
*
*                     VERIFY COMMAND
*
***********************************************************************
*
QFN10800 DS    0H
         LGHI  R15,0                  SET  ORDINAL NUMBER = 0           64MODE
*        ST    R15,EBW000             IN EBW000
*        LA    R15,EBW000
*        BAS   R4,GETISN              GET A RAND IS NUMBER
*        LA    R14,4                  PASS 4 BYTES
*        SWISC QFN3,TYPE=CREATE,IS=R5,LIST=#CLHRDY,LEV=NONE
         LGHI  R14,1                                                    64MODE
         CRETC S,QMS2,STATE=1052
         J     UNLOCK                                                   64MODE
         EJECT 1
***********************************************************************
*  GENERATE A RANDOM NUMBER FOR THE 'IS' TO PUT THE WORK ON.
***********************************************************************
GETISN   DS    0H
         DCTIST REG=R3
         CINFC R,CMMIST,F,REG=R3       GET IST ADDR
         SGR   R0,R0                                                    64MODE
         SGR   R14,R14                                                  64MODE
         LGH   R0,ISTUSEIS             USABLE I-STREAMS                 64MODE
         STCK  EBW000              STORE CLOCK VALUE
         LLGF  R15,EBW000+4       LOAD CLOCK VALUE                      64MODE
         N     R15,=X'0FFFFFFF'    KEEP NUMBER SMALL
         DR    R14,R0              DIVIDE BY INPUT NUMBER
         LA    R5,1(,R14)         RANDOM NMBR BETWEEN 1 & DIVISOR
         BR    R4
         EJECT  1
***********************************************************************
*  INITIALIZE THE QL0QL RECORD FOR ORDINAL NUMBER PASSED IN R2
***********************************************************************
INITQL   DS    0H
         LGR   R0,R2               QL ORDINAL                           64MODE
         LA    R6,=CL8'#QL0QL'
         LA    R7,CE1FA7
         ENTRC FACS
         LTGR  R0,R0                                                    64MODE
         JZ    QLERROR                                                  64MODE
         MVC   CE1FA7(4),=X'C3D90000'
         FILNC D7
         WAITC QLERROR
         BR    R4
QLERROR  DS    0H
         WTOPC TEXT='CORO64 DRIVER FIND ERROR ON QL0QL',               X
               NUM=11,LET=E,ROUT=(PRC,RO,RDBS)
         J     UNLOCK                                                   64MODE
*
         EJECT  1
***********************************************************************
*  SEIZE THE GLOBAL RECORD, ALL TO MYSELF
***********************************************************************
LOCK     DS    0H
         TS    SD0FLG2
         JZ    LOCKED                                                   64MODE
         DLAYC ,
         J     LOCK                                                     64MODE
LOCKED   DS    0H
         BR    R4
*
***********************************************************************
*  UNLOCK THE GLOBAL RECORD AND EXIT
***********************************************************************
UNLOCK   DS    0H
         MVI   SD0FLG2,X'00'
EXIT     DS    0H
         EXITC
         EJECT
***********************************************************************
*  DISPLAY SCREENS FORMATS
***********************************************************************
*
DISP1   DC AL1(DISP1E-DISP1-1)
        DC C'CORO64 DRIVER IS RUNNING ',AL1(#CAR)
        DC AL1(#CAR)
        DC C'REQUESTED ECBS=... NEST=... RIAT=.... FA=... CRETC=..'
        DC AL1(#CAR)
        DC C'RUNNING ECBS  =... '
        DC AL1(#CAR)
        DC C'TOTAL COMMITS   = ..........'
        DC AL1(#CAR)
        DC C'TOTAL ROLLBACKS = ..........'
        DC AL1(#CAR)
DISP1E  EQU *
*
DISP2   DC AL1(DISP2E-DISP2-1)
        DC C'CORO64 DRIVER IS STOPPING',AL1(#CAR)
        DC C'RUNNING ECBS=... ',AL1(#CAR)
DISP2E  EQU *
        DS  0D
         LTORG
         FINIS
         END
