         PRINT NOGEN
         BEGIN NAME=QMS1,AMODE=64,IBM=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2006                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
***********************************************************************
*
* MODULE NAME..... QMS1
* DESCRIPTION..... COMMIT SYSTEM TEST DRIVER
* RELATED MODULE.. QMS0 MONITOR SEGMENT
*                  QMS2 CORO DLM
* DOCUMENT NAME... CORO DRIVER USERS GUIDE
* LEVEL........... N/A
*
* FUNCTION...      THIS IS A GENERAL PURPOSE COMMIT/ROLLBACK DRIVER
*
*                  THIS IS THE COMMAND PARSER
*
* MODULE ATTRIBUTES..
*   TYPE.......... 'E' (ECB CONTROLLED)
*   DEPENDENCY.... NONE (OBJECT SHIPPABLE)
*   ALLOCATION.... 4K FILE RESIDENT
*   ENVIRONMENT... BASE, BSS
*   ENTRY POINT... QMS1  (ENTNC FROM CVZZ)
*
* ECB-CONVENTIONS.......
*
*   WORK AREA
*
* DATA LEVELS
*         NONE USED
*
* REGISTER-CONVENTIONS..
*
*
* TO USE...... QMS1 IS INVOKED VIA ZTEST COMMAND.
*
*        ZTEST CO64 CMD
*
*              CMD  =ACTION CODE
*                       START
*                       ALTER
*                       STOP
*                       STATUS
*                       VERIFY
         EJECT 1
***********************************************************************
* DSECTS
***********************************************************************
         DCTBPK REG=R6            MAP BPKDC OUTPUT LIST
*
         J     QFN20000                                                 64MODE
         DC    CL8'&SYSDATE',CL1' ',CL8'&SYSTIME'
*
QFN20000 DS    0H
***********************************************************************
* PARSE MESSAGE AND let it sit on data level 0
***********************************************************************
         BPKDC EXECUTE=YES,BPKD=MAINBPK,HELP=QFN29995,ERROR=QFN29995,  X
               EMSG=Y
***********************************************************************
*        goto the right routine
***********************************************************************
         LLGF  R6,CE1CR0          PROCESS MAINLINE COMMAND              64MODE
         LLGF  R7,ACTION                                                64MODE
         B     QFN20100(R7)       GO TO INDICATED ROUTINE
         SPACE 2
*
QFN20100 DS    0H                 BRANCH TABLE FOR CMDS
         J     QFN29995           INVALID INDEX GENERATED               64MODE
         J     QFN20200           ACTION IS 'START'                     64MODE
         J     QFN20300           ACTION IS 'STOP'                      64MODE
         J     QFN20400           ACTION IS 'STATUS'                    64MODE
         J     QFN20500           ACTION IS 'ALTER'                     64MODE
         J     QFN20600           ACTION IS 'ONCE'                      64MODE
         J     QFN20700           ACTION IS 'RESET'                     64MODE
         J     QFN20800           ACTION IS 'VERIFY'                    64MODE
         SPACE 2
         EJECT 1
***********************************************************************
*
*  START COMMAND
*
***********************************************************************
QFN20200 DS    0H                 CORO 'START COMMAND
         LGF   R14,POOLS                                                64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN20210                                                 64MODE
***********************************************************************
* VALIDATE THE POOLID PARAMETER
***********************************************************************
         CLC   1(3,R14),=C'SDP'
         JE    QFN20210                                                 64MODE
         CLC   1(3,R14),=C'LDP'
         JE    QFN20210                                                 64MODE
         CLC   1(3,R14),=C'4DP'
         JE    QFN20210                                                 64MODE
         CLC   1(3,R14),=C'SST'
         JE    QFN20210                                                 64MODE
         CLC   1(3,R14),=C'LST'
         JE    QFN20210                                                 64MODE
         CLC   1(3,R14),=C'4ST'
         JE    QFN20210                                                 64MODE
         LA    R2,QFN2M06
         BRAS  R4,QFN2WTPC                                              64MODE
         J     QFN29999                                                 64MODE
***********************************************************************
* VALIDATE THE FA PARAMETER
***********************************************************************
QFN20210 DS    0H
         LGF   R14,24(R6)              LOAD POINTER TO FA               64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN20215                                                 64MODE
         LLGF  R14,0(,R14)                                              64MODE
         CGHI  R14,200                                                  64MODE
         JH    QFN20220                                                 64MODE
***********************************************************************
* INPUT VALUES ARE OK, GO TO START
***********************************************************************
QFN20215 DS    0H
         MVC   EBW000(4),=C'STAR'
         LA    R2,QFN2M01
         BRAS  R4,QFN2WTPC                                              64MODE
         ENTNC QMS0               GO TO POLICE
***********************************************************************
* INVALID FA ADDRESS GIVEN . WTOPC AND EXIT
***********************************************************************
QFN20220 DS    0H
         LA    R2,QFN2M08
         BRAS  R4,QFN2WTPC                                              64MODE
         J     QFN29999                                                 64MODE
         EJECT 1
***********************************************************************
*
*  STOP  COMMAND
*
***********************************************************************
QFN20300 DS    0H                 CORO 'STOP' COMMAND
         MVC   EBW000(4),=C'STOP'
         ENTNC QMS0               GO TO POLICE
         EJECT 1
***********************************************************************
*
*  STATUS COMMAND
*
***********************************************************************
QFN20400 DS    0H                 CORO 'STATUS COMMAND
         MVC   EBW000(4),=C'STAT'
         ENTNC QMS0               GO TO POLICE
         SPACE 2
         EJECT 1
***********************************************************************
*
*  ALTER COMMAND
*
***********************************************************************
QFN20500 DS    0H
         LGF   R14,POOLS                                                64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN20510                                                 64MODE
***********************************************************************
* VALIDATE THE POOLID PARAMETER
***********************************************************************
         CLC   1(3,R14),=C'SDP'
         JE    QFN20510                                                 64MODE
         CLC   1(3,R14),=C'LDP'
         JE    QFN20510                                                 64MODE
         CLC   1(3,R14),=C'4DP'
         JE    QFN20510                                                 64MODE
         CLC   1(3,R14),=C'SST'
         JE    QFN20510                                                 64MODE
         CLC   1(3,R14),=C'LST'
         JE    QFN20510                                                 64MODE
         CLC   1(3,R14),=C'4ST'
         JE    QFN20510                                                 64MODE
***********************************************************************
* BAD POOLID PARAMETER GIVEN
***********************************************************************
         LA    R2,QFN2M06
         BRAS  R4,QFN2WTPC                                              64MODE
         J     QFN29999                                                 64MODE
***********************************************************************
* VALIDATE THE FA PARAMETER
***********************************************************************
QFN20510 DS    0H
         LGF   R14,24(R6)              LOAD POINTER TO FA               64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN20515                                                 64MODE
         LLGF  R14,0(,R14)                                              64MODE
         CGHI  R14,200                                                  64MODE
         JH    QFN20220                                                 64MODE
***********************************************************************
* INPUT VAULES ARE OK GO TO ALTER
***********************************************************************
QFN20515 DS    0H
         MVC   EBW000(4),=C'ALTE'
         ENTNC QMS0               GO TO POLICE
         EJECT 1
***********************************************************************
*
*  ONCE  COMMAND
*
***********************************************************************
QFN20600 DS    0H
         LGF   R14,POOLS                                                64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN20610                                                 64MODE
***********************************************************************
* VALIDATE POOLID PARAMETER
***********************************************************************
         CLC   1(3,R14),=C'SDP'
         JE    QFN20610                                                 64MODE
         CLC   1(3,R14),=C'LDP'
         JE    QFN20610                                                 64MODE
         CLC   1(3,R14),=C'4DP'
         JE    QFN20610                                                 64MODE
         CLC   1(3,R14),=C'SST'
         JE    QFN20610                                                 64MODE
         CLC   1(3,R14),=C'LST'
         JE    QFN20610                                                 64MODE
         CLC   1(3,R14),=C'4ST'
         JE    QFN20610                                                 64MODE
***********************************************************************
* BAD POOLID GIVEN
***********************************************************************
         LA    R2,QFN2M06
         BRAS  R4,QFN2WTPC                                              64MODE
         J     QFN29999                                                 64MODE
***********************************************************************
* VALIDATE THE FA PARAMETER
***********************************************************************
QFN20610 DS    0H
         LGF   R14,28(R6)              LOAD POINTER TO FA               64MODE
         LTGR  R14,R14                                                  64MODE
         JZ    QFN20615                                                 64MODE
         LLGF  R14,0(,R14)                                              64MODE
         CGHI  R14,200                                                  64MODE
         JH    QFN20220                                                 64MODE
***********************************************************************
* INPUT VAULES ARE OK GO TO DO ONCE
***********************************************************************
QFN20615 DS    0H
         MVC   EBW000(4),=C'ONCE'
         LA    R2,QFN2M05
         BRAS  R4,QFN2WTPC                                              64MODE
         ENTNC QMS0               GO TO POLICE
         EJECT 1
***********************************************************************
*
*  RESET COMMAND
*
***********************************************************************
QFN20700 DS    0H
         LA    R2,QFN2M04
         BRAS  R4,QFN2WTPC                                              64MODE
         MVC   EBW000(4),=C'RESE'
         ENTNC QMS0               GO TO POLICE
         EJECT 1
***********************************************************************
*
*  VERIFY COMMAND
*
***********************************************************************
QFN20800 DS    0H
         MVC   EBW000(4),=C'VERI'
         LA    R2,QFN2M07
         BRAS  R4,QFN2WTPC                                              64MODE
         ENTNC QMS0               GO TO POLICE
***********************************************************************
*
*  HELP  COMMAND
*
***********************************************************************
QFN29995 DS    0H                 CORO 'HELP' COMMAND
         LA    R2,HELPSCR
         BRAS  R4,QFN2HELP                                              64MODE
         J     QFN29999           CONTINUE ON OTHERWISE                 64MODE
         SPACE 1
***********************************************************************
*
*  EXIT
*
***********************************************************************
QFN29999 DS    0H
         CRUSA S0=2,S1=3
         EXITC ,
         EJECT 1
*
*  Messages
*
QFN2M01  GENMSG LET=I,NUM=01,TEXT='CORO64 DRIVER IS STARTING'
QFN2M04  GENMSG LET=I,NUM=04,TEXT='CORO64 DRIVER RESET BEGUN'
QFN2M05  GENMSG LET=I,NUM=05,TEXT='CORO64 DRIVER IS RUNNING ONCE'
QFN2M06  GENMSG LET=E,NUM=06,TEXT='INVALID POOLID VALUE GIVEN'
QFN2M07  GENMSG LET=I,NUM=07,TEXT='CORO64 DRIVER IS VERIFYING:'
QFN2M08  GENMSG LET=E,NUM=08,TEXT='INVALID FA VALUE. 200 MAX'
*
*  Skeleton WTOPC macros
*
         DCTMSG
         USING DCTMSG,R2
QFN2WTPC WTOPC PREFIX=QMS1,CHAIN=YES,ENDOFM=YES,                       X
               NUMA=MSGNUM,                                            X
               LETA=MSGLET,                                            X
               TEXTA=MSGLEN,                                           X
               COMP=YES,                                               X
               ROUT=(PRC,RO,RDBS)
         DROP  R2
         BR    R4
*
QFN2HELP WTOPC PREFIX=QMS1,CHAIN=YES,ENDOFM=YES,                       X
               TEXTA=(R2),                                             X
               COMP=YES,                                               X
               ROUT=(PRC,RO,RDBS)
         BR    R4
*
         EJECT 1
MAINBPK  BPKDC (PSR,ACTION,ACTBPP)
         SPACE 2
ACTBPP   BPPSC (START,4,STRTBPK),                                      X
               (STOP,3),                                               X
               (STATUS,4),                                             X
               (ALTER,1,STRTBPK),                                      X
               (ONCE,1,ONCEBPK),                                       X
               (RESET,1),                                              X
               (VERIFY,1)
         SPACE 2
STRTBPK  BPKDC (PSR,ACTION,ACTBPP),                                    X
               (KD,ECB,1,3),                                           X
               (KD,NEST,1,3),                                          X
               (KC,POOLID,1,3),                                        X
               (KD,FA,1,3),                                            X
               (KD,CRETC,1,2)
ONCEBPK  BPKDC (PSR,ACTION,ACTBPP),                                    X
               (KD,ECB,1,3),                                           X
               (KD,NEST,1,3),                                          X
               (KC,POOLID,2,3),                                        X
               (KC,PRT,2,1),                                           X
               (KD,FA,1,3)
*
         DS    0D
HELPSCR  DC    AL1(HELPEND-*-1)
         DC    C'ZTEST CO64 cmd  ',AL1(#CAR)
         DC    C' where cmd is:',AL1(#CAR)
         DC    C' STARt Ecb=N Nest=N Poolid=C Fa=N Cretc=N',AL1(#CAR)
         DC    C' Alter Ecb=N Nest=N Poolid=C Fa=N',AL1(#CAR)
         DC    C' Once  Ecb=N Nest=N Poolid=C PRt=Y',AL1(#CAR)
         DC    C' STATus',AL1(#CAR)
         DC    C' STOp',AL1(#CAR)
         DC    C' Reset',AL1(#CAR)
         DC    C' Verify',AL1(#CAR)
         DC    AL1(#CAR)
         DC    C'WHERE N IS A 3-DIGIT NUMBER',AL1(#CAR)
         DC    C'WHERE C IS SDP LDP 4DP SST LST 4ST',AL1(#CAR)
HELPEND  EQU *
*
*
*
*  ASSIGN MEANINGFUL NAMES TO THE LABELS GENERATED BY BPKDC
*
ACTION   EQU   BPKOPM1
ECBS     EQU   BPKOPM2
NESTS    EQU   BPKOPM3
POOLS    EQU   BPKOPM4
FA1      EQU   BPKOPM5
PRT      EQU   BPKOPM5
FA2      EQU   BPKOPM6
         LTORG
         FINIS QXND
         END   ,
