  #ifndef __tcoro_
  #define __tcoro_
/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      (C) Copyright IBM Corp. 2006                                 */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/* Header filename:  C_CORO.H                                        */
/* Header filetype:  TPF                                             */
/* Abstract:   header file for CORO (commit/rollback) test driver.   */
/*                                                                   */
/* Description:  definitions for CORO test driver.                   */
/*                                                                   */
/*********************************************************************/

#include <tpf/c_eb0eb.h>

typedef struct TESTBLK
  {
  char                 rid[2];  /* Basic ID                     */
  unsigned char        rcc;     /* Record code check            */
  char                 unused;  /* unused                       */
  char                 pgm[4];  /* program name                 */
  unsigned int         fwd;     /* forward chain                */
  unsigned int         bwd;     /* backward chain, not used     */
  int                  value;   /* value, for verification      */
  char                 tid[10]; /* transaction branch ID        */
  short                spare;
  int                  fcnt;    /* num of files chained to root */
  int                  chksum;  /* chksum of files chained      */
  } TESTBLK;

  #endif
